<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Notification;
use \Setforms2\Shared\ORM\DateTime;

class PlaValidacaoCardapio extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $parameterBagColumns;
    protected $environment;
    protected $estadoDoCardapio;
    protected $tipoDeVisualizacao;
    protected $dataSourceName;
    protected $statusCardapio;
    protected $compcarddel;
    protected $entityManager;
    protected $authController;
    protected $util;
    protected $libUtilities;
    
    const VALIDACAO_CARDAPIO = "pla_validacao_cardapio";

    public function __construct($crudService, $parameterBag, $dataSourceManager, $environment, $util, $newCode, $entityManager, $authController,$libUtilities) {
        $this->crudService          = $crudService;
        $this->parameterBag         = $parameterBag;
        $this->dataSourceManager    = $dataSourceManager;
        $this->environment          = $environment;
        $this->entityManager        = $entityManager;
        $this->authController       = $authController;
        $this->util                 = $util;
        $this->libUtilities         = $libUtilities;
    }
    
    
    public function validarCardapio(DTO\Request $request, DTO\Response $response) {

        $row = $request->getRow();

        $idpercomensprat = $this->verificaParamComensaisSemPrato($row);
        
        if($idpercomensprat == 'N'){
            $comensaisSemPrato = $this->retornaCardComemsaisSemPrato($row);
            if(!empty($comensaisSemPrato)){
                $response->addDataSet(new DataSet ('comensaisSemPrato', $comensaisSemPrato));
            }
        }
        
        
    }
    
    public function verificaParamComensaisSemPrato($row) {

        $query = "SELECT IDPERCOMENSPRAT FROM PARAMGERAL";
        
        $idpercomensprat = $this->entityManager->getConnection()->fetchAll($query);
        return $idpercomensprat[0]['IDPERCOMENSPRAT'];
        
    }
    
    public function retornaCardComemsaisSemPrato($row){
        
        $query = "SELECT CD.CDFILIAL ||  ' - '  || F.NMFILIAL AS CDFILIAL,
                         CD.CDSERVFILI || ' - ' || S.NMSERVICO AS CDSERVFILI,
                         CD.DTCARDAPIO 
                FROM CARDADIA CD
                LEFT JOIN FILIAL F ON CD.CDFILIAL = F.CDFILIAL
                LEFT JOIN SERVICO S ON CD.CDFILIAL = S.CDFILIAL
                                    AND CD.CDSERVFILI = S.CDSERVFILI
                WHERE NOT EXISTS(SELECT * FROM COMPCARD C
                                    WHERE C.CDFILIAL = :CDFILIAL
                                        AND C.NRCARDAPIO = CD.NRCARDAPIO)
                      AND CD.CDFILIAL = :CDFILIAL
                      AND CD.CDSERVFILI = :CDSERVFILI
                      AND CD.DTCARDAPIO BETWEEN TO_DATE(:DATA_INICIAL, 'DD/MM/YYYY') AND TO_DATE(:DATA_FINAL, 'DD/MM/YYYY')";
                      
        $param = array(
            
            'CDFILIAL' => $row['CDFILIAL'],
            'CDSERVFILI' => $row['CDSERVFILI'],
            'DATA_INICIAL' => $row['DATA_INICIAL'],
            'DATA_FINAL' => $row['DATA_FINAL']
        );
            
        $comensaisSemPrato = $this->entityManager->getConnection()->fetchAll($query, $param);
        return !empty($comensaisSemPrato) ? $comensaisSemPrato : null ;
    }


}